/* 
   bttvgrab 0.15.10 [2000-03-21]
   (c) 1998, 1999 by Joerg Walter <trouble@moes.pmnet.uni-oldenburg.de>
   Maintained by: Joerg Walter
   Current version at http://moes.pmnet.uni-oldenburg.de/bttvgrab/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <errno.h>
#include "error.h"
#include "transport.h"
#include "color.h"
#include "configuration.h"
#define SYMBOL(x) output_pnm_ ## x

/************ Prototypes ************/

void output_pnm_start(const char *format);
int output_pnm_write(char *buffer, int picnr);
void output_pnm_stop();

/************************************/

int output_pnm_fmts() { return 2; }
const char *output_pnm_fmt(int nr) { if (nr) return "ppm"; else return "pgm"; }

char output_pnm_magic[128] = "";

int output_pnm_width = 0, output_pnm_height = 0, output_pnm_bytes = 0;

START_DATA
INTOPTION(width,0,INT_MAX);
INTOPTION(height,0,INT_MAX);
OPTION(color_fmt) NOSET O_GET {
	if (!strcmp(format,"ppm")) {
		strcpy(value,"RGB24");
	} else if (!strcmp(format,"pgm")) {
		strcpy(value,"GREY8");
	} else {
		ERROR(INTMSG("invalid pnm type: %s"),format);
		exit(1);
	}
}
END_DATA


void output_pnm_start(const char *format)
{
	char tmp[20];

	strcpy(tmp,"color_fmt");
	output_pnm_inquire(format,tmp);
	if (!strcmp(tmp,"GREY8")) strcpy(output_pnm_magic,"P5");
	else if (!strcmp(tmp,"RGB24")) strcpy(output_pnm_magic,"P6");
	else {
		ERROR(INTMSG("invalid pnm color format: %s"),tmp);
		exit(1);
	}
	sprintf(output_pnm_magic+2,"\n%i %i\n255\n",output_pnm_width,output_pnm_height);
	strcpy(tmp,"color_fmt");
	output_pnm_inquire(format,tmp);
	output_pnm_bytes = color_bytes(color_val(tmp), output_pnm_width, output_pnm_height);

	transport_wstart(format,output_pnm_width,output_pnm_height,1);
}

int output_pnm_write(char *buffer, int picnr)
{
	transport_wframe(picnr);
	transport_write(output_pnm_magic,strlen(output_pnm_magic));
	transport_write(buffer,output_pnm_bytes);
	return 1;
}

void output_pnm_stop()
{
}
